#ifndef _XCHAR_H_
#define _XCHAR_H_

#if (defined(WIN32) && defined(UNICODE))

//xchar == wchar_t support

typedef wchar_t xchar;

#define _X(x)		L ## x

#define XCHAR_IS_WCHAR

#define xprintf		wprintf
#define xsprintf	wsprintf
#define xstrcpy		wcscpy
#define xstrncpy	wcsncpy
#define xstrlen		wcslen
#define xstrcat		wcscat
#define xsscanf		swscanf

#else

typedef char xchar;

#define _X(x)		x

#define XCHAR_IS_CHAR

#define xprintf		printf
#define	xsprintf	sprintf
#define xstrcpy		strcpy
#define xstrncpy	strncpy
#define xstrlen		strlen
#define xstrcat		strcat
#define xsscanf		sscanf

#endif

#define STRCPYPTR(a, b)												\
	if((b) == NULL)													\
	{																\
		(a) = NULL;													\
	}																\
	else															\
	{																\
		(a) = (xchar*)malloc(sizeof(xchar) * (xstrlen((b)) + 1));	\
		xstrcpy((a), (b));											\
	}

#ifdef XCHAR_IS_WCHAR

void			xconvert(wchar_t*, const char*, unsigned int);
void			xconvert(char*, const wchar_t*, unsigned int);
const wchar_t*	xcond(const char*, const wchar_t*);

#else if XCHAR_IS_CHAR

void			xconvert(char*, const char*, unsigned int);
const char*		xcond(const char*, const wchar_t*);

#endif


#endif
