#ifndef _XML_NODE_H_
#define _XML_NODE_H_

#include "List.h"
#include "Str.h"

namespace Framework
{

	namespace Xml
	{

		class CNode
		{
		public:
									CNode();
									CNode(const char*, bool);
									~CNode();

			void					InsertNode(CNode*);
			const char*				GetText();
			const char*				GetInnerText();
			bool					IsTag();

			CNode*					GetParent();
			unsigned int			GetChildCount();
			CNode*					GetFirstChild();
			CList<CNode>::ITERATOR	GetIterator();

			CNode*					Search(const char*);
			CNode*					Select(const char*);


		private:
			CStr			m_sText;
			CNode*			m_pParent;
			bool			m_nIsTag;
			CList<CNode>	m_Child;
		};

	}

}

#endif
