#ifndef _XML_PARSER_H_
#define _XML_PARSER_H_

#include "Node.h"
#include "Stream.h"
#include "Str.h"

namespace Framework
{
	
	namespace Xml
	{
		
		class CParser
		{
		public:
			static CNode*	ParseDocument(CStream*);

		private:
							CParser(CStream*, CNode*);
							~CParser();

			bool			Parse();
			void			DumpText();
			bool			ProcessChar_Text(char);
			bool			ProcessChar_Tag(char);

			enum STATE
			{
				STATE_TEXT,
				STATE_TAG,
			};

			CStream*		m_pStream;
			CNode*			m_pNode;
			CStr			m_sText;
			STATE			m_nState;
			bool			m_nIsTagEnd;
			bool			m_nTagSpace;
		};
	
	}

}

#endif
