#include "BitStream.h"

using namespace Framework;

CBitStream::CBitStream(CStream* pStream)
{
	m_pStream = pStream;
	m_nPointer = 0;
	m_nCache = 0;
}

uint8 CBitStream::GetBit()
{
	uint8 nTemp;
	if(m_nPointer == 0)
	{
		m_pStream->Read(&m_nCache, 1);
	}
	nTemp = (m_nCache & (1 << m_nPointer)) >> m_nPointer;
	m_nPointer++;
	m_nPointer &= 7;
	return nTemp;
}

uint32 CBitStream::GetBits(uint8 nCount)
{
	int i;
	uint32 nTemp;
	nTemp = 0;
	for(i = 0; i < nCount; i++)
	{
		nTemp |= (GetBit() << i);
	}
	return nTemp;
}
