#include "pthread.h"

int pthread_create(pthread_t* pThread, const pthread_attr_t* pAttr, void* (*pFunc)(void*), void* pParam)
{
	DWORD nTID;
	HANDLE nThread;
	nThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)pFunc, pParam, 0, &nTID);
	if(nThread == NULL)
	{
		return -1;
	}
	if(pThread != NULL)
	{
		*pThread = nThread;
	}
	return 0;
}

int pthread_cancel(pthread_t nThread)
{
	return TerminateThread(nThread, 0);
}

void pthread_exit(void* pParam)
{
	ExitThread((DWORD)pParam);
}

int pthread_join(pthread_t pThread, void** pReturn)
{
	DWORD nReturn;
	WaitForSingleObject(pThread, INFINITE);
	if(pReturn != NULL)
	{
		GetExitCodeThread(pThread, &nReturn);
		*pReturn = (void*)nReturn;
	}
	return 0;
}
